<?php
// $Id$
 
/**
 * @file
 * Provides integration between the main Fusion Charts module and Views
 */

/**
 * Style plugin to render each item as a row in a table.
 */
class fusioncharts_views_style_plugin extends views_plugin_style {
  /**
   * Render the given style.
   */
  function options_form(&$form, &$form_state) {    
    $chart_types = fusioncharts_settings('fusioncharts');
    
    $handlers = $this->display->handler->get_handlers('field');
    $field_names = $this->display->handler->get_field_labels();
    $count = count($handlers);
    foreach ($handlers as $id => $handler) {
      $fields[$id] = $handler->ui_name();
    }
    
    $id = 'edit-style-options-chart-type';

    if ($this->view === TRUE) {
      $form['error_markup'] = array(
        '#value' => t('Please enable Grouping to use the FussionCharts views.'),
        '#prefix' => '<div class="error form-item description">',
        '#suffix' => '</div>',
      );
      return;
    }
    elseif ($count < 2) {
      $form['error_markup'] = array(
        '#value' => t('You need at least one field for the x axis and one for the y axis before you can configure Fusion Charts settings'),
        '#prefix' => '<div class="error form-item description">',
        '#suffix' => '</div>',
      );      
      return;
    }

    $form['chart_type'] = array(
      '#type' => 'select',
      '#options' => $chart_types,
      '#default_value' => isset($this->options['chart_type']) ? $this->options['chart_type'] : '',
    );
    
    $form['field_value'] = array(
      '#type' => 'select',
      '#title' => t('Field that contains the value to be plotted'),
      '#options' => $fields,
      '#default_value' => isset($this->options['field_value']) ? $this->options['field_value'] : '',
      '#process' => array('views_process_dependency'),
      '#dependency' => array($id => array('Column 3D', 'Column 2D', 'Line 2D', 'Area 2D', 'Bar 2D', 'Pie 2D', 'Pie 3D', 'Doughnut 2D', 'Funnel Chart', 'Multi-series Column 2D', 'Multi-series Column 3D', 'Multi-series Line 2D', 'Multi-series Bar 2D', 'Multi-series Area 2D', 'Stacked Column 3D', 'Stacked Column 2D', 'Stacked Bar 2D', 'Stacked Area 2D')),
      );
    $form['field_primary'] = array(
      '#type' => 'select',
      '#title' => t('Field that contains the value to be plotted on the primary axis'),
      '#options' => $fields,
      '#default_value' => isset($this->options['field_value']) ? $this->options['field_value'] : '',
      '#process' => array('views_process_dependency'),
      '#dependency' => array($id => array('Multi-series Column 2D + Line - Dual Y Axis', 'Multi-series Column 3D + Line - Dual Y Axis')),
      );
    $form['field_secondary'] = array(
      '#type' => 'select',
      '#title' => t('Field that contains the value to be plotted on the secondary axis'),
      '#options' => $fields,
      '#default_value' => isset($this->options['field_value']) ? $this->options['field_value'] : '',
      '#process' => array('views_process_dependency'),
      '#dependency' => array($id => array('Multi-series Column 2D + Line - Dual Y Axis', 'Multi-series Column 3D + Line - Dual Y Axis')),
      );

    $form['field_name'] = array(
      '#type' => 'select',
      '#title' => t('Field that contains the names for the x-axis'),
      '#options' => $fields,
      '#default_value' => isset($this->options['field_name']) ? $this->options['field_name'] : '',
      '#process' => array('views_process_dependency'),
      '#dependency' => array($id => array('Column 3D', 'Column 2D', 'Line 2D', 'Area 2D', 'Bar 2D', 'Pie 2D', 'Pie 3D', 'Doughnut 2D', 'Funnel Chart')),
    );
    
    $form['field_series'] = array(
      '#type' => 'select',
      '#title' => t('Field that contains the series'),
      '#options' => $fields,
      '#default_value' => isset($this->options['field_series']) ? $this->options['field_series'] : '',
      '#process' => array('views_process_dependency'),
      '#dependency' => array($id => array('Multi-series Column 2D', 'Multi-series Column 3D', 'Multi-series Line 2D', 'Multi-series Bar 2D', 'Multi-series Area 2D', 'Stacked Column 3D', 'Stacked Column 2D', 'Stacked Bar 2D', 'Stacked Area 2D', 'Multi-series Column 2D + Line - Dual Y Axis', 'Multi-series Column 3D + Line - Dual Y Axis')),
    );
    $form['field_category'] = array(
      '#type' => 'select',
      '#title' => t('Field that contains the category'),
      '#options' => $fields,
      '#default_value' => isset($this->options['field_category']) ? $this->options['field_category'] : '',
      '#process' => array('views_process_dependency'),
      '#dependency' => array($id => array('Multi-series Column 2D', 'Multi-series Column 3D', 'Multi-series Line 2D', 'Multi-series Bar 2D', 'Multi-series Area 2D', 'Stacked Column 3D', 'Stacked Column 2D', 'Stacked Bar 2D', 'Stacked Area 2D', 'Multi-series Column 2D + Line - Dual Y Axis', 'Multi-series Column 3D + Line - Dual Y Axis')),
    );
  }
}